//
//  main.swift
//  SIPObjC
//
//  Created by Emilio P Egido on 27/2/25.
//

import Foundation

    let csrConfig = csrActiveConfig()
    var sipStatus = (csrConfig == 0) ? "Enabled" : "Disabled"

    // If Enabled, Apple Silicon may display only "Enabled", hex value is missing
    // If Disabled, both platforms Intel and Silicon display "sipStatus + hex value"
    var sipValue = ""

    if sipStatus == "Enabled" {
        sipValue = "System Integrity Protection: \(sipStatus) (0x00000000)"
    }
    else {
        sipValue = "System Integrity Protection: \(sipStatus) (0x\(String(format:"%08x", csrConfig)))"
    }

//    let sipValue = "System Integrity Protection: \(sipStatus) (0x\(String(format:"%08x", csrConfig)))"
    
    print("\n\(sipValue)\n")
 
 func csrActiveConfig() -> UInt32 {
    let config = SIPObjC() // reference to Objective-C file
    var csrConfig = UInt32(config.sipValue()) // method of the Objective-C file (long >> UInt32)
    csrConfig = csrConfig.byteSwapped // big endian to litle endian e.g. 00000803 to 03080000
    return csrConfig
 }
